/*
 * CustomerFactory.java
 *
 * Created on February 8, 2002, 9:02 PM
 */

package com.systinet.demos.bank.simple;

import com.systinet.demos.bank.Account;
import com.systinet.demos.bank.Transfer;
import com.systinet.demos.bank.Balance;
import com.systinet.demos.bank.Customer;
import com.systinet.demos.bank.CustomerFactory;
import com.systinet.demos.bank.CustomerNotFoundException;

/**
 *
 * @author  zdenek
 */
public class CustomerFactoryImpl implements CustomerFactory {

    private static java.util.HashMap customers = new java.util.HashMap();
    
    static {
        init();
    }
    
    public Customer createCustomer(String ssn) throws CustomerNotFoundException {
        if(customers.containsKey(ssn))
            return (Customer)customers.get(ssn);   
        else 
            throw new CustomerNotFoundException("Customer with SSN "+ssn+" doesn't exists.");
    }
    
    public static void init() {
        try {
            CustomerImpl customer = new CustomerImpl();
            customer.setSSN("001-0001-01");
            customer.setFirstname("Zdenek");
            customer.setLastname("Svoboda");
            customer.setAddress("1 Broadway, 14th floor");
            customer.setCity("Cambridge");
            customer.setState("MA");
            customer.setCountry("USA");
            customer.setZIP("02142");
            customer.setPhone("(617) 475 1540");
            customer.setFax("(617) 758 4101");
            customer.setEmail("zdenek.svoboda@systinet.com");
            customer.createAccount("C");
            customer.createAccount("S");

            customers.put(customer.getSSN(), customer);

            Account[] accounts = customer.getAccounts();
            for(int i=0;i<accounts.length; i++) {
                TransferImpl transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary(accounts[i].getAccountNumber());
                transfer.setAccountNumber("28178432743-002");
                transfer.setAmount((i+1)*1000);
                transfer.setType("W");
                transfer.setComment("Salary");
                transfer.setCommentBeneficiary("Salary");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("28178145666-027");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*500);
                transfer.setType("W");
                transfer.setComment("Rent");
                transfer.setCommentBeneficiary("Rent");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("28178145666-019");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*50);
                transfer.setType("W");
                transfer.setComment("Electricity");
                transfer.setCommentBeneficiary("Electricity");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("28178145666-019");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*10);
                transfer.setType("W");
                transfer.setComment("Phone");
                transfer.setCommentBeneficiary("Phone");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*25);
                transfer.setType("T");
                transfer.setComment("Teller transaction");
                transfer.setCommentBeneficiary("Teller transaction");
                accounts[i].processTransfer(transfer);
            }

						/*
            for(int i=0;i<accounts.length; i++) {
                System.out.println("");
                System.out.println("ACCOUNT "+accounts[i].getAccountNumber()+" balance "+accounts[i].getLastBalance().getBalance());
                System.out.println("");
                System.out.println("Balances");
                System.out.println("------------");
                Balance[] balances = accounts[i].getBalanceHistory();
                for(int j=0;j<balances.length; j++) {
                    System.out.println(balances[j].getChanged()+"\t"+balances[j].getBalance());
                }
                System.out.println("");
                System.out.println("Transfers");
                System.out.println("---------");
                Transfer[] transfers = accounts[i].getTransferHistory();
                for(int j=0;j<transfers.length; j++) {
                    System.out.println(transfers[j].getTimestamp()+"\t"+transfers[j].getAmount()+"\t"+transfers[j].getComment());
                }
            }

            System.out.println("");
            System.out.println("");
						*/
            
            customer = new CustomerImpl();
            customer.setSSN("002-0002-02");
            customer.setFirstname("Roman");
            customer.setLastname("Stanek");
            customer.setPhone("(617) 475 1542");
            customer.setEmail("roman.stanek@systinet.com");
            customer.createAccount("C");
            customer.createAccount("S");

            customers.put(customer.getSSN(), customer);

            accounts = customer.getAccounts();
            for(int i=0;i<accounts.length; i++) {
                TransferImpl transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary(accounts[i].getAccountNumber());
                transfer.setAccountNumber("28178432743-002");
                transfer.setAmount((i+1)*1000);
                transfer.setType("W");
                transfer.setComment("Salary");
                transfer.setCommentBeneficiary("Salary");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("28178145666-027");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*500);
                transfer.setType("W");
                transfer.setComment("Rent");
                transfer.setCommentBeneficiary("Rent");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("28178145666-019");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*50);
                transfer.setType("W");
                transfer.setComment("Electricity");
                transfer.setCommentBeneficiary("Electricity");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("28178145666-019");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*10);
                transfer.setType("W");
                transfer.setComment("Phone");
                transfer.setCommentBeneficiary("Phone");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*25);
                transfer.setType("T");
                transfer.setComment("Teller transaction");
                transfer.setCommentBeneficiary("Teller transaction");
                accounts[i].processTransfer(transfer);
            }

						/*
            for(int i=0;i<accounts.length; i++) {
                System.out.println("");
                System.out.println("ACCOUNT "+accounts[i].getAccountNumber()+" balance "+accounts[i].getLastBalance().getBalance());
                System.out.println("");
                System.out.println("Balances");
                System.out.println("------------");
                Balance[] balances = accounts[i].getBalanceHistory();
                for(int j=0;j<balances.length; j++) {
                    System.out.println(balances[j].getChanged()+"\t"+balances[j].getBalance());
                }
                System.out.println("");
                System.out.println("Transfers");
                System.out.println("---------");
                Transfer[] transfers = accounts[i].getTransferHistory();
                for(int j=0;j<transfers.length; j++) {
                    System.out.println(transfers[j].getTimestamp()+"\t"+transfers[j].getAmount()+"\t"+transfers[j].getComment());
                }
            }

            System.out.println("");
            System.out.println("");
            */
            
            customer = new CustomerImpl();
            customer.setSSN("003-0003-03");
            customer.setFirstname("Wendell");
            customer.setLastname("Lansford");
            customer.setPhone("(617) 475 1541");
            customer.setEmail("wendell.lansford@systinet.com");
            customer.createAccount("C");
            customer.createAccount("S");

            customers.put(customer.getSSN(), customer);

            accounts = customer.getAccounts();
            for(int i=0;i<accounts.length; i++) {
                TransferImpl transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary(accounts[i].getAccountNumber());
                transfer.setAccountNumber("28178432743-002");
                transfer.setAmount((i+1)*1000);
                transfer.setType("W");
                transfer.setComment("Salary");
                transfer.setCommentBeneficiary("Salary");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("28178145666-027");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*500);
                transfer.setType("W");
                transfer.setComment("Rent");
                transfer.setCommentBeneficiary("Rent");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("28178145666-019");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*50);
                transfer.setType("W");
                transfer.setComment("Electricity");
                transfer.setCommentBeneficiary("Electricity");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("28178145666-019");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*10);
                transfer.setType("W");
                transfer.setComment("Phone");
                transfer.setCommentBeneficiary("Phone");
                accounts[i].processTransfer(transfer);
                
                transfer = new TransferImpl();
                transfer.setAccountNumberBeneficiary("");
                transfer.setAccountNumber(accounts[i].getAccountNumber());
                transfer.setAmount((-1)*(i+1)*25);
                transfer.setType("T");
                transfer.setComment("Teller transaction");
                transfer.setCommentBeneficiary("Teller transaction");
                accounts[i].processTransfer(transfer);
            }

						/*
            for(int i=0;i<accounts.length; i++) {
                System.out.println("");
                System.out.println("ACCOUNT "+accounts[i].getAccountNumber()+" balance "+accounts[i].getLastBalance().getBalance());
                System.out.println("");
                System.out.println("Balances");
                System.out.println("------------");
                Balance[] balances = accounts[i].getBalanceHistory();
                for(int j=0;j<balances.length; j++) {
                    System.out.println(balances[j].getChanged()+"\t"+balances[j].getBalance());
                }
                System.out.println("");
                System.out.println("Transfers");
                System.out.println("---------");
                Transfer[] transfers = accounts[i].getTransferHistory();
                for(int j=0;j<transfers.length; j++) {
                    System.out.println(transfers[j].getTimestamp()+"\t"+transfers[j].getAmount()+"\t"+transfers[j].getComment());
                }
            }
            */
            
        }
        catch (Exception e) {
            e.printStackTrace();
        }

    }
    
}