package com.systinet.demos.weather;

import org.idoox.wasp.Context;
import org.idoox.webservice.client.WebServiceLookup;

public final class WeatherClient {

    public static void main( String[] args ) throws Exception {
        
      String zip = "02451";
      
      if(args != null && args.length > 0 && args[0] != null) {
      	zip = args[0];
      }
      else {
      	System.err.println("Usage: run_weather_client.bat ZIP");
      	System.err.println("No ZIP supplied. Using default 02451.");
      }
      // lookup service
      WebServiceLookup lookup = (WebServiceLookup)Context.getInstance(Context.WEBSERVICE_LOOKUP);
      // bind to Weather Service
      WeatherRetrieverSoap weatherService = (WeatherRetrieverSoap)lookup.lookup("http://www.vbws.com/services/weatherretriever.asmx?WSDL",new javax.wsdl.QName("http://tempuri.org/", "WeatherRetriever"), "WeatherRetrieverSoap", WeatherRetrieverSoap.class);
      
      // use Weather Service
      System.out.println("\n\nGetting Current Weather in "+zip);
      System.out.println("-------------------------------------");
      CurrentWeather weather = weatherService.GetWeather(zip);
      
      System.out.println("Last updated:        "+weather.LastUpdated);
      System.out.println("Weather Conditions:  "+weather.Conditions);
      System.out.println("Temperature:         "+weather.CurrentTemp);
      System.out.println("Humidity:            "+weather.Humidity);
      System.out.println("Barometer:           "+weather.Barometer);
      System.out.println("Barometer Direction: "+weather.BarometerDirection);

    }

}